/* M:/72_INP/11__ClassMembers.jsh
Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó

Příkazy a úryvky zadávané ve výpisech v kapitole:
11  Třídy a jejich členy
/*************************************************************************/


/*
** Výpis 11.0: Inicializace prostředí – definice pomocných metod a proměnných
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Výpis 11.1:	Definice třídy Empty
********************************************************************/
class Empty {}
new Empty();
/********************************************************************


/*
** Výpis 11.2:	Definice třídy Empty s explicitně definovaným konstruktorem
********************************************************************/
class Empty
{
    Empty()
    {
        println("Vytvářím instanci třídy Empty: " + this);
    }
}
/2
/********************************************************************


/*
** Výpis 11.3:	Přehled dosavadních úryvků této lekce – celá definice
 *				třídy je jeden úryvek
********************************************************************/
/list
/********************************************************************


/*
** Výpis 11.4:	Definice třídy AllMembers
********************************************************************/
class AllMembers
{
//== Sekce deklarující členy třídy = statické členy ======================

    /** Statický atribut (atribut třídy)
     *  určený k počítání vytvořených instancí. */
    static int created = 0;

    /** Konstruktor objektu třídy. Nemůžeme jej zavolat.
     *  Je zavolán v okamžiku, kdy se zjistí, že třídu někdo potřebuje,
     *  a musí se proto vytvořit její objekt. */
    static {
        println("Vytvářím objekt třídy AllMembers");
    }

    /** Statická metoda (metoda třídy)
     *  vypisující počet doposud vytvořených instancí. */
    static void printCreated()
    {
        println("Doposud vytvořeno " + created + " instancí");
    }


//== Sekce deklarující členy instancí ====================================

    /** Instanční atribut pamatující si pořadí vytvoření dané instance
     *  (její rodné číslo). V rámci jeho inicializace se inkrementuje
     *  statický atribut počítající vytvořené instance. */
    int ID = ++created;

    /** Konstruktor zodpovědný za inicializaci instance. */
    AllMembers()
    {
        println("Vytvářím instanci s ID=" + ID);
    }

    /** Instanční metoda vracející textový podpis instance. */
    public String toString()
    {
        return "AllMembers_" + ID;
    }
}
/********************************************************************


/*
** Výpis 11.5:	Vytváření instancí třídy AllMembers
********************************************************************/
new AllMembers();
AllMembers[] arAM = {null, $6, new AllMembers(), new AllMembers()};
/********************************************************************


/*
** Výpis 11.6:	Zasílání zpráv instancím třídy AllMembers
********************************************************************/
AllMembers.printCreated();
$6.toString();
_int = AllMembers.created;
_int = $6.ID;
arAM[3].toString();
/********************************************************************


/*
** Výpis 11.7:	Definice třídy MC s trojicí konstruktorů
********************************************************************/
class MC   //Multiple constructors
{
//== Sekce deklarující členy třídy = statické členy ======================

    /** Počet doposud vytvořených instancí. */
    static int created = 0;


//== Sekce deklarující členy instancí ====================================

    /** Rodné číslo vytvořené instance. */ int    ID;
    /** Upřesňující název instance.     */ String name;
    /** Obalovaný objekt.               */ Object wrapped;

    /** Bezparametrický konstruktor. */
    MC()
    {
        this("");
        println("   Za použití bezparametrického konstruktoru");
    }

    /** Konstruktor upřesňující název instance. */
    MC(String name)
    {
        this(null, name);
        println("   Za použití jednoparametrického konstruktoru");
    }

    /** Konstruktor zadávající obalovaný objekt. */
    MC(Object wrapped, String name)
    {
        this.ID      = ++created;
        this.name    = name;
        this.wrapped = wrapped;
        println("Vytvářím: " + this);
    }

    /** Instanční metoda vracející textový podpis instance. */
    public String toString()
    {
        return "MC(č. " + ID
             + ((name == null)  ?  " bez upřesňujícího názvu"
                                :  " nazvaná «" + name + "»")
             + ((wrapped == null)  ?  " nic neobalující"
                                   :  " obalující «" + wrapped + "»")
             + ')';
    }
}
/********************************************************************


/*
** Výpis 11.8:	Vytváření instancí třídy MC
********************************************************************/
{
MC mc0   = new MC(),
   mc1   = new MC("Jednoparametrický"),
   mc2S  = new MC("Obalený string", "Balí string"),
   mc2O  = new MC(new Object(),     null),
   mc2MC = new MC(mc2S,             "");
}
/********************************************************************


/*
** Výpis 11.9:	Autoboxing – automatické převody hodnot primitivních
 *				typů na instance příslušných obalových typů a zpět
********************************************************************/
Integer čtyřka = 4;
int čtyři = čtyřka;
čtyřka + new Double(3.14);
čtyřka + 3.14;
čtyřka + Double.valueOf(3.14);
/********************************************************************


/*
** Výpis 11.10:	Převody stringů na hodnoty primitivních typů
********************************************************************/
String number = " 12345 ";
int i = Integer.parseInt(number);
i = Integer.parseInt(number.trim());
/********************************************************************


/*
** Výpis X.0: Popis
********************************************************************/
//Komunikace s příkazovým panelem
/********************************************************************


/*
** Výpis X.0: Popis
********************************************************************/
                                                               //SYNC
/* Kód je uložen v souboru:
M:/72_INP/XXX.java
*/
