package b72_j21ref.c17_inheritance;
/* M:/72_Java/b72_j21ref/c17_inheritance/Granddaughter17.java
 * Příliš žluťoučký kůň úpěl ďábelské ó - PŘÍLIŠ ŽLUŤOUČKÝ KŮŇ ÚPĚL ĎÁBELSKÉ Ó
 */

import static b72_j21ref.c17_inheritance.Reports17.*;



/*******************************************************************************
 * Instance třídy {@code Granddaughter17} představují vnučky.
 * Třída je součástí skupiny tříd demonstrující vlastnosti dědění.
 *
 * @author  Rudolf PECINOVSKÝ
 * @version 2023-Summer
 */
public class Granddaughter17 extends Daughter17
{
    static { println("#####  Zavádím třídu Granddaughter17  #####"); }
    { println("+++++  Inicializuji instanci třídy Granddaughter17  +++++"); }

    /** Počet doposud vytvořených instancí.*/
    protected static int created = 0;

    /** Rodné číslo instance = pořadí jejího vzniku v rámci této třídy. */
    protected final String ID = "G"  + ++created + '-' + super.ID;


    /***************************************************************************
     * Konstruktor instance vnučky.
     * Rodičovským podobjektem je virtuální instance třídy {@link Daughter17}.
     */
    public Granddaughter17()
    {
        this(null);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kteří potřebují něco provést
     * před zavoláním rodičovského konstruktoru.
     *
     * @param s Nepoužitý parametr
     */
    protected Granddaughter17(String s)
    {
        super(intermezzo("=== Granddaughter17 volá rodičovský konstruktor"));
        constructorReport(this, Granddaughter17.class);
    }

    /***************************************************************************
     * Vrátí textový podpis instance, tj. její textovou reprezentaci.
     *
     * @return Textová reprezentace (podpis) dané instance
     */
    @Override
    public String toString()
    {
        return "Granddaughter17_" + ID + "(" + super.toString() + ")";
    }

    { println("-----  Konec úvodní fáze inicializace Granddaughter17  -----"); }
    static { println("-----  Třída Granddaughter17 zavedena  -----"); }
}
